package examples.addressbook;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

import java.util.Hashtable;
import java.util.Enumeration;
public class AddressBook extends ActorReference  {
	public AddressBook selfReference;

	public AddressBook(UAN uan) { super(uan); }
	public AddressBook(UAL ual) { super(ual); }

	public static void main(String args[]) {
		AddressBook instance = new AddressBook();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public AddressBook() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected AddressBook self = selfReference;
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		Hashtable name2email;
		State() {
			self.ual = __ual;
			Vector messages = new Vector();

			name2email = new Hashtable();
			ServiceFactory.getTransport().send(messages);
		}
		public String getName(String email) {
			System.err.println("getting name by email: " + email);
			if (name2email.contains(email)) {
				Enumeration e = name2email.keys();
				while (e.hasMoreElements()) {
					String name = (String) e.nextElement();
					String e_mail = (String) name2email.get(name);
					if (email.compareTo(e_mail) == 0) {
						return name;
					}
				}
			}
			return new String("Unknown user");
		}
		public String getEmail(String name) {
			System.err.println("Getting email by name: " + name);
			if (name2email.containsKey(name)) {
				return (String) name2email.get(name);
			}
			return new String("Unknown user");
		}
		public boolean addUser(String name, String email) {
			System.err.println("added user: " + name + ", " + email);
			if (name2email.containsKey(name) || name2email.contains(email)) {
				return false;
			}
			name2email.put(name, email);
			return true;
		}
		public void act(String args[]) {
			if (args.length != 2) {
				{
					// standardOutput<-println("Usage: java examples.addressbook.AddressBook <UAN> <UAL>")
					{
						Message message = new Message( self, standardOutput, "println", null );
						Object _arguments[] = { "Usage: java examples.addressbook.AddressBook <UAN> <UAL>" };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
				return;
			}
			{
				// bind(args[0], args[1])
				{
					Message message = new Message( self, self, "bind", null );
					Object _arguments[] = { args[0], args[1] };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
	}
}