package examples.heat;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

import java.io.*;
import java.util.*;
public class DistributedHeat extends ActorReference  {
	public DistributedHeat selfReference;

	public DistributedHeat(UAN uan) { super(uan); }
	public DistributedHeat(UAL ual) { super(ual); }

	public static void main(String args[]) {
		DistributedHeat instance = new DistributedHeat();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public DistributedHeat() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected DistributedHeat self = selfReference;
		public State() {
			self.ual = __ual;
		}
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		int iterations = 100;
		int x = 120;
		int y = 120;
		int actors = 2;
		long initialTime;
		String nameServer = "n1.ns.cs.rpi.edu";
		String theatersFile = "cluster.txt";
		String fileName = "heat-salsa.map";
		public double[][] createInitialData() {
			double[][] data = new double[x][];
			for (int i = 0; i < x; i++){
				data[i] = new double[y];
				for (int j = 0; j < y; j++){
					data[i][j] = 20.0;
					if (i == 0 || j == 0 || i == x - 1 || j == y - 1) data[i][j] = 20.0;
					if (j == 0 && i > x / 4 && i < 3 * x / 4) data[i][j] = 100.0;
				}
			}
			return data;
		}
		public void produceFile(double[][] data, String fileName) {
			try {
				PrintWriter out = new PrintWriter(new FileWriter(fileName));
				out.println(x + " " + y);
				for (int i = 0; i < x; i++){
					for (int j = 0; j < y; j++)out.println(data[i][j]);
				}
				out.flush();
				out.close();
			}
			catch (IOException ioe) {
				{
					// standardOutput<-println("[error] Can't open the file " + fileName + " for writing.")
					{
						Message message = new Message( self, standardOutput, "println", null );
						Object _arguments[] = { "[error] Can't open the file " + fileName + " for writing." };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
			}

		}
		public double[][] doWork(double[][] data, int iterations, int noActors, String nameServer, String theatersFile) {
			int rowsPerActor = x / noActors;
			HeatWorker[] workers = new HeatWorker[noActors];
			for (int a = 0; a < noActors; a++){
				int i = a * rowsPerActor;
				double[][] workerData = new double[rowsPerActor][];
				for (int j = 0; j < rowsPerActor; j++){
					workerData[j] = new double[y];
					System.arraycopy(data[i], 0, workerData[j], 0, y);
					i++;
				}
				workers[a] = new HeatWorker(workerData);
			}
			{
				// standardOutput<-println(self + " connecting worker neighbors")
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { self + " connecting worker neighbors" };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			for (int a = 0; a < noActors; a++){
				if (a > 0) 				{
					// workers[a]<-connectTop(workers[a - 1])
					{
						Message message = new Message( self, workers[a], "connectTop", null );
						Object _arguments[] = { workers[a - 1] };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
				if (a < noActors - 1) 				{
					// workers[a]<-connectBottom(workers[a + 1])
					{
						Message message = new Message( self, workers[a], "connectBottom", null );
						Object _arguments[] = { workers[a + 1] };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
			}
			Vector theaters = new Vector();
			String theater;
			try {
				BufferedReader in = new BufferedReader(new FileReader(theatersFile));
				while ((theater=in.readLine()) != null) {
					theaters.add(theater);
				}
				in.close();
			}
			catch (IOException ioe) {
				{
					// standardOutput<-println("[error] Can't open the file " + fileName + " for writing.")
					{
						Message message = new Message( self, standardOutput, "println", null );
						Object _arguments[] = { "[error] Can't open the file " + fileName + " for writing." };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
			}

			for (int a = 0; a < noActors; a++){
				{
					// standardOutput<-println("Sending actor " + "uan://" + nameServer + ":3030/a" + a + " to " + "rmsp://" + theaters.get(a % theaters.size()) + "/a" + a)
					{
						Message message = new Message( self, standardOutput, "println", null );
						Object _arguments[] = { "Sending actor " + "uan://" + nameServer + ":3030/a" + a + " to " + "rmsp://" + theaters.get(a % theaters.size()) + "/a" + a };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
				{
					// workers[a]<-bind("uan://" + nameServer + ":3030/a" + a, "rmsp://" + theaters.get(a % theaters.size()) + "/a" + a)
					{
						Message message = new Message( self, workers[a], "bind", null );
						Object _arguments[] = { "uan://" + nameServer + ":3030/a" + a, "rmsp://" + theaters.get(a % theaters.size()) + "/a" + a };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
			}
			{
				// standardOutput<-println(">>>>>>Starting the computation")
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { ">>>>>>Starting the computation" };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			initialTime = System.currentTimeMillis();
			{
				Token token_2_0 = new Token();
				// join block
				token_2_0.setJoinToken();
				for (int a = 0; a < noActors; a++)				{
					// workers[a]<-doWork(new Integer(iterations))
					{
						Message message = new Message( self, workers[a], "doWork", token_2_0.createInput() );
						Object _arguments[] = { new Integer(iterations) };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
				// composeMatrix(token)
				{
					Message message = new Message( self, self, "composeMatrix", currentContinuation );
					Object _arguments[] = { token_2_0.createOutput(self, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				currentContinuation = null;
				throw new CurrentContinuationException();
			}
		}
		public void endTimer() {
			long finalTime = System.currentTimeMillis();
			long runningTime = finalTime - initialTime;
			double processingRate = 1.0 * iterations * (x - 2) * (y - 2) / runningTime;
			{
				// standardOutput<-println("Time for " + iterations + " iterations on " + (x - 2) + "," + (y - 2) + " grid: " + runningTime + " ms.")
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { "Time for " + iterations + " iterations on " + (x - 2) + "," + (y - 2) + " grid: " + runningTime + " ms." };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			{
				// standardOutput<-println("Execution rate: " + processingRate + " points/ms")
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { "Execution rate: " + processingRate + " points/ms" };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
		public double[][] composeMatrix(Object[] results) {
			double[][] cresults;
			double[][] m = new double[x][];
			int i = 0;
			for (int a = 0; a < results.length; a++){
				cresults = (double[][]) results[a];
				for (int j = 0; j < cresults.length; j++){
					m[i] = new double[y];
					System.arraycopy(cresults[j], 0, m[i], 0, y);
					i++;
				}
			}
			{
				// endTimer()
				{
					Message message = new Message( self, self, "endTimer", null );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			{
				// standardOutput<-println("Returned matrix size:" + m.length + "," + m[0].length)
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { "Returned matrix size:" + m.length + "," + m[0].length };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			return m;
		}
		public void act(String args[]) {
			int argc = args.length;
			if (argc >= 1) actors = Integer.parseInt(args[0]);
			if (argc >= 2) x = Integer.parseInt(args[1]);
			if (argc >= 3) y = Integer.parseInt(args[2]);
			if (argc >= 4) iterations = Integer.parseInt(args[3]);
;			if (argc >= 5) nameServer = args[4];
			if (argc >= 6) theatersFile = args[5];
			if (argc >= 7) fileName = args[6];
			x += 2;
			y += 2;
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				// createInitialData()
				{
					Message message = new Message( self, self, "createInitialData", token_2_0.createInput() );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				// doWork(token, new Integer(iterations), new Integer(actors), nameServer, theatersFile)
				{
					Message message = new Message( self, self, "doWork", token_2_1.createInput() );
					Object _arguments[] = { token_2_0.createOutput(self, message, 0), new Integer(iterations), new Integer(actors), nameServer, theatersFile };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				// produceFile(token, fileName)
				{
					Message message = new Message( self, self, "produceFile", null );
					Object _arguments[] = { token_2_1.createOutput(self, message, 0), fileName };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
	}
}