package examples.language;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

public class TokenPrinter extends ActorReference  {
	public TokenPrinter selfReference;

	public TokenPrinter(UAN uan) { super(uan); }
	public TokenPrinter(UAL ual) { super(ual); }

	public static void main(String args[]) {
		TokenPrinter instance = new TokenPrinter();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public TokenPrinter() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected TokenPrinter self = selfReference;
		public State() {
			self.ual = __ual;
		}
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		public int compute() {
			return 5;
		}
		public String computeString() {
			return "a string";
		}
		public Object computeObject() {
			return new Integer(5);
		}
		public void print(int number) {
			{
				// standardOutput<-println(new Integer(number + 2))
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { new Integer(number + 2) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
		public void print(Integer number) {
			{
				// standardOutput<-println(number)
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { number };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
		public void print(String string) {
			{
				// standardOutput<-println(string + " indeed.")
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { string + " indeed." };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
		public void print(Object object) {
			{
				// standardOutput<-println("Object:" + object)
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { "Object:" + object };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
		public void act(String[] args) {
			{
				Token token_2_0 = new Token();
				// compute()
				{
					Message message = new Message( self, self, "compute", token_2_0.createInput() );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				// print(token)
				{
					Message message = new Message( self, self, "print", null );
					Object _arguments[] = { token_2_0.createOutput(self, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
			}
			{
				Token token_2_0 = new Token();
				// computeString()
				{
					Message message = new Message( self, self, "computeString", token_2_0.createInput() );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				// print(token)
				{
					Message message = new Message( self, self, "print", null );
					Object _arguments[] = { token_2_0.createOutput(self, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
			}
			{
				Token token_2_0 = new Token();
				// computeObject()
				{
					Message message = new Message( self, self, "computeObject", token_2_0.createInput() );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				// print(token)
				{
					Message message = new Message( self, self, "print", null );
					Object _arguments[] = { token_2_0.createOutput(self, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
			}
			int i = 0;
			String s = "s";
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				Token token_2_2 = new Token();
				Token token_2_3 = new Token();
				// print(1)
				{
					Message message = new Message( self, self, "print", token_2_0.createInput() );
					Object _arguments[] = { new Integer(1) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				// print(s)
				{
					Message message = new Message( self, self, "print", token_2_1.createInput() );
					Object _arguments[] = { s };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_0.createOutput(self, message, -1) );
					messages.add( message );
				}
				// print("a" + "b")
				{
					Message message = new Message( self, self, "print", token_2_2.createInput() );
					Object _arguments[] = { "a" + "b" };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_1.createOutput(self, message, -1) );
					messages.add( message );
				}
				// print(new Integer(1))
				{
					Message message = new Message( self, self, "print", token_2_3.createInput() );
					Object _arguments[] = { new Integer(1) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_2.createOutput(self, message, -1) );
					messages.add( message );
				}
				// print(new Integer(1 + 1))
				{
					Message message = new Message( self, self, "print", null );
					Object _arguments[] = { new Integer(1 + 1) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_3.createOutput(self, message, -1) );
					messages.add( message );
				}
			}
		}
	}
}