package examples.migration;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

public class Agent extends ActorReference  {
	public Agent selfReference;

	public Agent(UAN uan) { super(uan); }
	public Agent(UAL ual) { super(ual); }

	public static void main(String args[]) {
		Agent instance = new Agent();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public Agent() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected Agent self = selfReference;
		public State() {
			self.ual = __ual;
		}
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		StringBuffer itinerary;
		UAL initialLocation;
		long initialTime;
		int hops;
		public void startTime() {
			initialTime = System.currentTimeMillis();
		}
		public void addLocation(String ual) {
			if (itinerary == null) {
				itinerary = new StringBuffer(ual);
				try {
					initialLocation = new UAL(ual);
				}
				catch (SalsaException e) {
					{
						// standardError<-println(e)
						{
							Message message = new Message( self, standardError, "println", null );
							Object _arguments[] = { e };
							message.setArguments( _arguments );
							message.setRequiredTokens( 0 );
							message.setInput( null );
							messages.add( message );
						}
					}
				}

			}
			else {
				hops++;
				itinerary.append(" " + ual);
			}
		}
		public void printItinerary() {
			{
				// standardOutput<-println(itinerary)
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { itinerary };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
		public void printTime() {
			{
				// standardOutput<-println("Migrated " + hops + " times.")
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { "Migrated " + hops + " times." };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			System.err.println("processing a print time message");
			if (self.getUAL().equals(initialLocation)) {
				{
					Token token_3_0 = new Token();
					// standardOutput<-println("Time ellapsed: " + new Long(System.currentTimeMillis() - initialTime))
					{
						Message message = new Message( self, standardOutput, "println", token_3_0.createInput() );
						Object _arguments[] = { "Time ellapsed: " + new Long(System.currentTimeMillis() - initialTime) };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
					// standardOutput<-println("Migration avg time: " + new Long((System.currentTimeMillis() - initialTime) / hops))
					{
						Message message = new Message( self, standardOutput, "println", null );
						Object _arguments[] = { "Migration avg time: " + new Long((System.currentTimeMillis() - initialTime) / hops) };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( token_3_0.createOutput(standardOutput, message, -1) );
						messages.add( message );
					}
				}
			}
		}
		public void go(String[] args, String iS) {
			int i = Integer.parseInt(iS);
			if (i < args.length) {
				if (!args[i].startsWith(">>")) {
					{
						Token token_4_0 = new Token();
						Token token_4_1 = new Token();
						Token token_4_2 = new Token();
						Token token_4_3 = new Token();
						// addLocation(args[i])
						{
							Message message = new Message( self, self, "addLocation", token_4_0.createInput() );
							Object _arguments[] = { args[i] };
							message.setArguments( _arguments );
							message.setRequiredTokens( 0 );
							message.setInput( null );
							messages.add( message );
						}
						// migrate(args[i])
						{
							Message message = new Message( self, self, "migrate", token_4_1.createInput() );
							Object _arguments[] = { args[i] };
							message.setArguments( _arguments );
							message.setRequiredTokens( 0 );
							message.setInput( token_4_0.createOutput(self, message, -1) );
							messages.add( message );
						}
						// printItinerary()
						{
							Message message = new Message( self, self, "printItinerary", token_4_2.createInput() );
							Object _arguments[] = {  };
							message.setArguments( _arguments );
							message.setRequiredTokens( 0 );
							message.setInput( token_4_1.createOutput(self, message, -1) );
							messages.add( message );
						}
						// printTime()
						{
							Message message = new Message( self, self, "printTime", token_4_3.createInput() );
							Object _arguments[] = {  };
							message.setArguments( _arguments );
							message.setRequiredTokens( 0 );
							message.setInput( token_4_2.createOutput(self, message, -1) );
							messages.add( message );
						}
						// go(args, String.valueOf(++i))
						{
							Message message = new Message( self, self, "go", null );
							Object _arguments[] = { args, String.valueOf(++i) };
							message.setArguments( _arguments );
							message.setRequiredTokens( 0 );
							message.setInput( token_4_3.createOutput(self, message, -1) );
							messages.add( message );
						}
					}
				}
			}
		}
		public void act(String[] args) {
			try {
				{
					Token token_3_0 = new Token();
					Token token_3_1 = new Token();
					Token token_3_2 = new Token();
					Token token_3_3 = new Token();
					// addLocation(args[1])
					{
						Message message = new Message( self, self, "addLocation", token_3_0.createInput() );
						Object _arguments[] = { args[1] };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
					// bind(args[0], args[1])
					{
						Message message = new Message( self, self, "bind", token_3_1.createInput() );
						Object _arguments[] = { args[0], args[1] };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( token_3_0.createOutput(self, message, -1) );
						messages.add( message );
					}
					// startTime()
					{
						Message message = new Message( self, self, "startTime", token_3_2.createInput() );
						Object _arguments[] = {  };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( token_3_1.createOutput(self, message, -1) );
						messages.add( message );
					}
					// printItinerary()
					{
						Message message = new Message( self, self, "printItinerary", token_3_3.createInput() );
						Object _arguments[] = {  };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( token_3_2.createOutput(self, message, -1) );
						messages.add( message );
					}
					// go(args, "2")
					{
						Message message = new Message( self, self, "go", null );
						Object _arguments[] = { args, "2" };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( token_3_3.createOutput(self, message, -1) );
						messages.add( message );
					}
				}
			}
			catch (Exception e) {
				{
					// standardOutput<-println(e)
					{
						Message message = new Message( self, standardOutput, "println", null );
						Object _arguments[] = { e };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
				{
					// standardOutput<-println("Usage: java migration.Agent UAN UAL (<UAL>)*")
					{
						Message message = new Message( self, standardOutput, "println", null );
						Object _arguments[] = { "Usage: java migration.Agent UAN UAL (<UAL>)*" };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
			}

		}
	}
}