package examples.migration;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

import salsa.naming.*;
public class LargeUniversalActor extends ActorReference  {
	public LargeUniversalActor selfReference;

	public LargeUniversalActor(UAN uan) { super(uan); }
	public LargeUniversalActor(UAL ual) { super(ual); }

	public static void main(String args[]) {
		LargeUniversalActor instance = new LargeUniversalActor();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public LargeUniversalActor() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public LargeUniversalActor(int size) {
		selfReference = this;
		State state = new State(size);
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected LargeUniversalActor self = selfReference;
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		byte[] largeData;
		State() {
			self.ual = __ual;
			Vector messages = new Vector();

			ServiceFactory.getTransport().send(messages);
		}
		State(int size) {
			self.ual = __ual;
			Vector messages = new Vector();

			largeData = new byte[size];
			ServiceFactory.getTransport().send(messages);
		}
		public void act(String args[]) {
			try {
				int howMany = Integer.parseInt(args[0]);
				int size = Integer.parseInt(args[1]);
				UAN uan = new UAN(args[2]);
				UAL ual = new UAL(args[3]);
				long initialTime = System.currentTimeMillis();
				for (int i = 0; i < howMany; i++){
					LargeUniversalActor a = new LargeUniversalActor(size);
					{
						// a<-bind(uan, ual)
						{
							Message message = new Message( self, a, "bind", null );
							Object _arguments[] = { uan, ual };
							message.setArguments( _arguments );
							message.setRequiredTokens( 0 );
							message.setInput( null );
							messages.add( message );
						}
					}
				}
				long finalTime = System.currentTimeMillis();
				{
					// standardOutput<-println(howMany + " Large actor creations.  " + "Time taken (ms): " + (finalTime - initialTime))
					{
						Message message = new Message( self, standardOutput, "println", null );
						Object _arguments[] = { howMany + " Large actor creations.  " + "Time taken (ms): " + (finalTime - initialTime) };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
			}
			catch (ArrayIndexOutOfBoundsException e) {
				{
					// standardOutput<-println("Usage: java migration.LargeUniversalActor " + "<howMany> <size> <UAN> <UAL>")
					{
						Message message = new Message( self, standardOutput, "println", null );
						Object _arguments[] = { "Usage: java migration.LargeUniversalActor " + "<howMany> <size> <UAN> <UAL>" };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
			}
			catch (Exception e) {
				{
					// standardOutput<-println(e)
					{
						Message message = new Message( self, standardOutput, "println", null );
						Object _arguments[] = { e };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
			}

		}
	}
}