package examples.sender;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

public class Startup extends ActorReference  {
	public Startup selfReference;

	public Startup(UAN uan) { super(uan); }
	public Startup(UAL ual) { super(ual); }

	public static void main(String args[]) {
		Startup instance = new Startup();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public Startup() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected Startup self = selfReference;
		public State() {
			self.ual = __ual;
		}
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		public void act(String args[]) {
			if (args.length != 4) {
				System.out.println("arg1 = location of naming server");
				System.out.println("arg2 = location of sender");
				System.out.println("arg3 = location of reciever");
				System.out.println("arg4 = message size");
				System.exit(0);
			}
			System.out.println("sender uan = " + args[0] + "sender");
			System.out.println("sender ual = " + args[1] + "sender");
			System.out.println("reciever uan = " + args[0] + "reciever");
			System.out.println("reciever ual = " + args[2] + "reciever");
			Reciever reciever = new Reciever();
			Sender sender = new Sender(Integer.parseInt(args[3]));
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				Token token_2_2 = new Token();
				// sender<-bind(args[0] + "sender", args[1] + "sender")
				{
					Message message = new Message( self, sender, "bind", token_2_0.createInput() );
					Object _arguments[] = { args[0] + "sender", args[1] + "sender" };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				// reciever<-bind(args[0] + "reciever", args[2] + "reciever")
				{
					Message message = new Message( self, reciever, "bind", token_2_1.createInput() );
					Object _arguments[] = { args[0] + "reciever", args[2] + "reciever" };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_0.createOutput(reciever, message, -1) );
					messages.add( message );
				}
				// sender<-connect(args[0] + "reciever")
				{
					Message message = new Message( self, sender, "connect", token_2_2.createInput() );
					Object _arguments[] = { args[0] + "reciever" };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_1.createOutput(sender, message, -1) );
					messages.add( message );
				}
				// sender<-go()
				{
					Message message = new Message( self, sender, "go", null );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_2.createOutput(sender, message, -1) );
					messages.add( message );
				}
			}
		}
	}
}