package io.ars;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

import io.IOTheater;
import io.core.agents.ProfilingAgent;
import java.util.Vector;
import salsa.language.ServiceFactory;
import salsa.messaging.TheaterService;
import salsa.naming.NamingService;
import salsa.naming.UAL;
import salsa.naming.UAN;
public class ARSDecisionActor extends ActorReference  {
	public ARSDecisionActor selfReference;

	public ARSDecisionActor(UAN uan) { super(uan); }
	public ARSDecisionActor(UAL ual) { super(ual); }

	public static void main(String args[]) {
		ARSDecisionActor instance = new ARSDecisionActor();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public ARSDecisionActor() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected ARSDecisionActor self = selfReference;
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		ARSProfilingAgent profilingAgent = (ARSProfilingAgent) IOTheater.getProfilingAgent();
		ActorReference protocolActor = null;
		int sleepTime = 10000;
		State() {
			self.ual = __ual;
			Vector messages = new Vector();

			this.reName("/system/decisionActor");
						{
				// begin()
				{
					Message message = new Message( self, self, "begin", null );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			ServiceFactory.getTransport().send(messages);
		}
		public void begin() {
			if (protocolActor == null) protocolActor = IOTheater.getProtocolActor();
			if (System.getProperty("silent") == null) {
				{
					// standardOutput<-println(System.currentTimeMillis() + "\t" + profilingAgent.processed() + "\t\t" + profilingAgent.getActorProfiles().size())
					{
						Message message = new Message( self, standardOutput, "println", null );
						Object _arguments[] = { System.currentTimeMillis() + "\t" + profilingAgent.processed() + "\t\t" + profilingAgent.getActorProfiles().size() };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
			}
			if (!profilingAgent.isComputing()) 			{
				// protocolActor<-leaveComputation()
				{
					Message message = new Message( self, protocolActor, "leaveComputation", null );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			if (profilingAgent.isLight() && !profilingAgent.isWaiting() && profilingAgent.isComputing()) 			{
				// protocolActor<-initiateSteal(new Double(processing))
				{
					Message message = new Message( self, protocolActor, "initiateSteal", null );
					Object _arguments[] = { new Double(processing) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			profilingAgent.reset();
			{
				// ()begin:((new Integer(sleepTime)))
				{
					Message message = new Message( self, self, "begin", null );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					Object[] _propertyInfo = { new Integer(sleepTime) };
					message.setProperty( "delay", _propertyInfo );
					messages.add( message );
				}
			}
		}
		double processing = profilingAgent.getProcessing();
		private double usedProcessing() {
			return processing / profilingAgent.getActorProfiles().size();
		}
		private double availableProcessing() {
			return processing / (profilingAgent.getActorProfiles().size() + 1);
		}
		private double decisionFunction(ActorProfile candidate, UAL source, double procesing) {
			String localId = protocolActor.getUAL().getLocation().toString();
			String foreignId = source.getLocation();
			double gain;
			gain = candidate.processed() * (processing / usedProcessing());
			gain += (candidate.sentTo(foreignId) - candidate.sentTo(localId));
			gain += (candidate.receivedFrom(foreignId) - candidate.receivedFrom(localId));
			gain /= candidate.processed();
			gain -= 1;
			return gain;
		}
		public ActorReference getBestCandidate(UAL source, double processing) {
			ActorProfile candidate = null;
			double candidateGain = 0;
			if (!profilingAgent.isComputing()) 			return null;
			Vector actorProfiles = profilingAgent.getActorProfiles();
			for (int i = 0; i < actorProfiles.size(); i++){
				ActorProfile current = (ActorProfile) actorProfiles.get(i);
				if (!current.getScheduled()) {
					double gain = decisionFunction(current, source, processing);
					if (gain > candidateGain) {
						candidate = current;
						candidateGain = gain;
					}
				}
			}
			if (candidate != null) {
				candidate.setScheduled(true);
				return new ActorReference(candidate.getActor().getUAN());
			}
			return null;
		}
	}
}