package io.resources;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

public class Leave extends ActorReference  {
	public Leave selfReference;

	public Leave(UAN uan) { super(uan); }
	public Leave(UAL ual) { super(ual); }

	public static void main(String args[]) {
		Leave instance = new Leave();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public Leave() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected Leave self = selfReference;
		public State() {
			self.ual = __ual;
		}
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		public void act(String[] arguments) {
			if (arguments.length < 1) {
				System.err.println("Usage: java io.resources.Purge <ProtocolActor UAL>*");
				System.err.println("removes all the protocol actors from their computations");
			}
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				// join block
				token_2_0.setJoinToken();
				for (int i = 0; i < arguments.length; i++){
					UAL ual = new UAL(arguments[i]);
					if (ual.getIdentifier().equals("/system/protocolActor")) {
						{
							Token token_5_0 = new Token();
							// new ActorReference(ual)<-leaveComputation()
							{
								Message message = new Message( self, new ActorReference(ual), "leaveComputation", token_5_0.createInput() );
								Object _arguments[] = {  };
								message.setArguments( _arguments );
								message.setRequiredTokens( 0 );
								message.setInput( null );
								messages.add( message );
							}
							// standardOutput<-println("Left computation: " + ual.toString())
							{
								Message message = new Message( self, standardOutput, "println", token_2_0.createInput() );
								Object _arguments[] = { "Left computation: " + ual.toString() };
								message.setArguments( _arguments );
								message.setRequiredTokens( 0 );
								message.setInput( token_5_0.createOutput(standardOutput, message, -1) );
								messages.add( message );
							}
						}
					}
					else {
						{
							// standardOutput<-println("Invalid ual: " + ual.toString())
							{
								Message message = new Message( self, standardOutput, "println", token_2_0.createInput() );
								Object _arguments[] = { "Invalid ual: " + ual.toString() };
								message.setArguments( _arguments );
								message.setRequiredTokens( 0 );
								message.setInput( null );
								messages.add( message );
							}
						}
					}
				}
				// standardOutput<-println("Finished.")
				{
					Message message = new Message( self, standardOutput, "println", token_2_1.createInput() );
					Object _arguments[] = { "Finished." };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_0.createOutput(standardOutput, message, -1) );
					messages.add( message );
				}
				// completed()
				{
					Message message = new Message( self, self, "completed", null );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_1.createOutput(self, message, -1) );
					messages.add( message );
				}
			}
		}
		public void completed() {
			System.exit(0);
		}
	}
}