package salsa.resources;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;

public class StandardOutput extends ActorReference{

	private static StandardOutput instance;

	private StandardOutput() {
		ual = ServiceFactory.getTheater().generateUAL();                
		Actor state = new State();         
		state.__ual = ual;
		ServiceFactory.getTheater().setEntry(ual, state);
	}

	public static synchronized StandardOutput getInstance() {
		if (instance == null) instance = new StandardOutput();

		return instance;
	}

	public class State extends Actor {
		public State() {
			this.reName("/system/standardOutput");
			RunTime.removedUniversalActor();
		}

		public void print(Object p)		{ System.out.print(p); }
		public void print(boolean p)		{ System.out.print(p); }
		public void print(char p)		{ System.out.print(p); }
		public void print(byte p)		{ System.out.print(p); }
		public void print(short p)		{ System.out.print(p); }
		public void print(int p)		{ System.out.print(p); }
		public void print(long p)		{ System.out.print(p); }
		public void print(float p)		{ System.out.print(p); }
		public void print(double p)		{ System.out.print(p); }

		public void println(Object p)		{ System.out.println(p); }
		public void println(boolean p)		{ System.out.println(p); }
		public void println(char p)		{ System.out.println(p); }
		public void println(byte p)		{ System.out.println(p); }
		public void println(short p)		{ System.out.println(p); }
		public void println(int p)		{ System.out.println(p); }
		public void println(long p)		{ System.out.println(p); }
		public void println(float p)		{ System.out.println(p); }
		public void println(double p)		{ System.out.println(p); }
		public void println()			{ System.out.println(); }
	}
}
