/*
	Code generation for the following grammar segment:
	
	JoinBlock := "join" Block()
*/

package salsac.definitions;

import salsac.*;

public class JoinBlock extends SimpleNode {

	public JoinBlock(int id) 		{ super(id); }
	public JoinBlock(SalsaParser p, int id)	{ super(p, id); }

	public String getChildCode() {
		String code = "";

		code += SalsaCompiler.getIndent() + SalsaCompiler.symbolTable.getContinuationOutput() + ".setJoinToken();\n";

		if (getChild(0).children == null) {
			System.err.println("Syntax Error: line: " + getToken(0).beginLine);
			System.err.println("\tEmpty Join Blocks are not allowed.");
			System.exit(0);
		} else {
			for (int i = 0; i < getChild(0).children.length; i++) {
				code += getChild(0).getChild(i).getJavaCode();
			}
		}
		return code;
	}
}
