/*
	Code generation for the following grammar segment:
	
	MethodDeclaration :=
		MethodAttributes (Type | "void") <IDENTIFIER> FormalParameters ["throws" Exceptions] Block
*/

package salsac.definitions;

import salsac.*;

public class MethodDeclaration extends SimpleNode {

	public MethodDeclaration(int id) 		{ super(id); }
	public MethodDeclaration(SalsaParser p, int id)	{ super(p, id); }

	public String getJavaCode() {
		String code = getChild(0).getJavaCode();
		if (code.equals("")) code += "public ";

		int i = 0;
		if ( !getToken(0).image.equals("void") ) {
			code += getChild(1).getJavaCode() + " " + getToken(0).image + getChild(2).getJavaCode();

			if (tokens.length > 1) {
				code += " throws " + getChild(3).getJavaCode();
				i = 4;
			} else {
				code += " ";
				i = 3;
			}
		} else {
			code += getToken(0).image + " " + getToken(1).image + getChild(1).getJavaCode();

			if (tokens.length > 2) {
				code += " throws " + getChild(2).getJavaCode();
				i = 3;
			} else {
				code += " ";
				i = 2;
			}
		}
		code += getChild(i).getJavaCode();

		return code;
	}
}
