/*
	Code generation for the following grammar segments:
	
	PrimaryPrefix :=
		  Literal()
		| "this"
		| "super" "." <IDENTIFIER>
		| "(" Expression() ")"
		| AllocationExpression()
		| Name()
*/

package salsac.definitions;

import salsac.*;

public class PrimaryPrefix extends SimpleNode {

	public PrimaryPrefix(int id) 			{ super(id); }
	public PrimaryPrefix(SalsaParser p, int id)	{ super(p, id); }

	public String getJavaCode() {
		if (tokens != null && getToken(0).image.equals("super") ) return "super";
		if (tokens != null && getToken(0).image.equals("this")) {
			if ( parent.jjtGetParent() instanceof MessageSend ) return "self";
			else return "this";
		}

		if (children == null) {
			System.err.println("big problem!");
		}
		
		switch (getChild(0).id) {
			case SalsaParserTreeConstants.JJTLITERAL:
			case SalsaParserTreeConstants.JJTALLOCATIONEXPRESSION:
			case SalsaParserTreeConstants.JJTNAME:
				return getChild(0).getJavaCode();
			
			case SalsaParserTreeConstants.JJTEXPRESSION:
				return "(" + getChild(0).getJavaCode() + ")";
				
			case SalsaParserTreeConstants.JJTRESULTTYPE:
				return getChild(0) + getTokenCode();
		}
		
		return "";
	}
}
